Siatka: Cecha

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page Mesh Feature and the translation is 3% complete.
Other languages:
Deutsch • ‎English • ‎français • ‎italiano • ‎polski

Introduction

Mesh Tree.svg

A Mesh Feature object, or formally a Mesh::Feature, is a simple element with an associated mesh object that can be displayed in the 3D view.

A Mesh Feature is similar conceptually to a Part Feature; the former is the base object for elements with "mesh" information, while the latter is the base object for elements with "geometrical shape" information.

Please note that the FEM Workbench also uses meshes, but it uses a different object, called FEM FemMeshObject (Fem::FemMeshObject class). This object is not derived from the Mesh Feature and has different properties.

FreeCAD core objects.svg

Simplified diagram of the relationships between the core objects in FreeCAD

Usage

Almost all mesh objects created by the commands available in the Mesh Workbench are Mesh Features. The parametric mesh objects created by the Mesh BuildRegularSolid command are the only exception. A Mesh Feature can also be created from the Python console as described in the Scripting section.

The Mesh::Feature is defined in the Mesh Workbench but can be used as the base class for scripted objects in all workbenches that produce 2D and 3D meshes.

A Mesh::Feature has simple properties like a placement, and visual properties to define the appearance of its edges and faces.

Properties

See Property for all property types that scripted objects can have.

The Mesh Feature (Mesh::Feature class) is derived from the basic App GeoFeature (App::GeoFeature class) and inherits all its properties. It also has several additional properties. Notably a DANEMesh property, which stores its Mesh MeshObject. This is the geometry that is shown in the 3D view.

These are the properties available in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Data

Base

  • DANE (Hidden)Proxy (PythonObject): a custom class associated with this object. This only exists for the Python version. See Scripting.
  • DANEMesh (MeshKernel): a Mesh MeshObject class associated with this object. It lists the number of Points, Edges, and Faces of the mesh.
  • DANEPlacement (Placement): the position of the object in the 3D view. The placement is defined by a Base point (vector), and a Rotation (axis and angle). See Placement.
    • DANEAngle: the angle of rotation around the DANEAxis. By default, it is (zero degrees).
    • DANEAxis: the unit vector that defines the axis of rotation for the placement. Each component is a floating point value between 0 and 1. If any value is above 1, the vector is normalized so that the magnitude of the vector is 1. By default, it is the positive Z axis, (0, 0, 1).
    • DANEPosition: a vector with the 3D coordinates of the base point. By default, it is the origin (0, 0, 0).
  • DANELabel (String): the user editable name of this object, it is an arbitrary UTF8 string.
  • DANE (Hidden)Label2 (String): a longer, user editable description of this object, it is an arbitrary UTF8 string that may include newlines. By default, it is an empty string "".
  • DANE (Hidden)Expression Engine (ExpressionEngine): a list of expressions. By default, it is empty [].
  • DANE (Hidden)Visibility (Bool): whether to display the object or not.

View

Base

  • WIDOK (Hidden)Proxy (PythonObject): a custom viewprovider class associated with this object. This only exists for the Python version. See Scripting.

Display Options

  • WIDOKBounding Box (Bool): if it is true, the object will show the bounding box in the 3D view.
  • WIDOKDisplay Mode (Enumeration): Shaded (no edges), Wireframe (no faces), Flat Lines (regular visualization), Points (only vertices).
  • WIDOKShow In Tree (Bool): if it is true, the object appears in the Tree view. Otherwise, it is set as invisible.
  • WIDOKVisibility (Bool): if it is true, the object appears in the 3D view; otherwise it is invisible. By default this property can be toggled on and off by pressing the Space bar.

Object Style

  • WIDOK (Hidden)Coloring (Bool): it defaults to false.
  • WIDOKCrease Angle (FloatConstraint):
  • WIDOKLighting (Enumeration): One side (default), Two side; the illumination comes from two sides or one side in the 3D view.
  • WIDOKLine Color (Color): a tuple of three floating point RGB values (r,g,b) to define the color of the edges in the 3D view; by default it is (0.0, 0.0, 0.0), which is displayed as [0,0,0] on base 255, completely black .
  • WIDOKLine Transparency (Percent): an integer from 0 to 100 (a percentage) that determines the level of transparency of the edges in the 3D view. A value of 100 indicates completely invisible edges; the edges are invisible but they can still be picked as long as WIDOKSelectable is true.
  • WIDOKLine Width (FloatConstraint): a float that determines the width in pixels of the edges in the 3D view. It defaults to 1.0.
  • WIDOKOpen Edges (Bool): it defaults to false.
  • WIDOKPoint Size (FloatConstraint): similar to WIDOKLine Width, defines the size of the vertices.
  • WIDOKShape Color (Color): similar to WIDOKLine Color, defines the color of the faces. It defaults to (0.8, 0.8, 0.8), which is displayed as [204,204,204] on base 255, a light gray.
  • WIDOK (Hidden)Shape Material (Material): an App Material associated with this object. By default it is empty.
  • WIDOKTransparency (Percent): an integer from 0 to 100 (a percentage) that determines the level of transparency of the faces in the 3D view. A value of 100 indicates completely invisible faces; the faces are invisible but they can still be picked as long as WIDOKSelectable is true.

Selection

  • WIDOKOn Top When Selected (Enumeration): Disabled (default), Enabled, Object, Element.
  • WIDOKSelectable (Bool): if it is true, the object can be picked with the pointer in the 3D view. Otherwise, the object cannot be selected until this option is set to true.
  • WIDOKSelection Style (Enumeration): Shape (default), BoundBox. If the option is Shape, the entire shape (vertices, edges, and faces) will be highlighted in the 3D view; if it is BoundBox only the bounding box will be highlighted.

Scripting

See also: FreeCAD Scripting Basics and scripted objects.

See Part Feature for the general information on adding objects to the document.

A Mesh Feature is created with the addObject() method of the document.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Mesh::Feature", "Name")
obj.Label = "Custom label"

For Python subclassing you should create the Mesh::FeaturePython object.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Mesh::FeaturePython", "Name")
obj.Label = "Custom label"